// +------------------+
// | Author: Greek2me |
// | BLID: 11902      |
// +------------------+

$Pref::MaxFontSize = 20;

function fontSize_parseML(%flag)
{
	for(%i=0; %i < strLen(%flag); %i++)
	{
		%char = getSubStr(%flag,%i,1);

		if(%char $= "<")
			%start = %i;

		if(%char $= ">" && %start !$= "")
		{
			%end = %i;

			%full = getSubStr(%flag,%start,%end-%start+1);
			%contents = getSubStr(%full,1,strLen(%full) - 2);

			%search = %contents;
			%pos = -1;
			%numValues = 0;
			while(strPos(%search,":") >= 0)
			{
				%search = getSubStr(%search,%pos+1,strLen(%search));

				%pos = strPos(%search,":");
				if(%pos >= 0)
				{
					%value[%numValues] = getSubStr(%search,0,%pos);
				}
				else
				{
					%value[%numValues] = %search;
				}
				%numValues ++;
			}

			if(%numValues <= 0)
			{
				if(%contents !$= "")
				{
					%value[0] = %contents;
					%numValues = 1;
				}
			}

			%replace = fontSize_parseMLReplace(%value0,%value1,%value2,%value3,%value4,%value5,%value6,%value7,%value8,%value9,%value10,%value11,%value12,%value13,%value14,%value15);

			if(%replace !$= "")
			{
				%flag = strReplace(%flag,%full,%replace);
				%i = %start-1;
			}

			%start = "";
			%end = "";
			%full = "";
			%contents = "";
			%search = "";
			%replace = "";
			for(%e=0; %e < %numValues; %e++)
				%value[%e] = "";
			%numValues = "";
		}
	}

	return %flag;
}

function fontSize_parseMLReplace(%value0,%value1,%value2,%value3,%value4,%value5,%value6,%value7,%value8,%value9,%value10,%value11,%value12,%value13,%value14,%value15)
{
	switch$(%value[0])
	{
		case "font":
			if(%value[2] > $Pref::MaxFontSize)
			{
				%replace = "<font:" @ %value[1] @ ":" @ $Pref::MaxFontSize @ ">";
			}
	}

	return %replace;
}

package MaxFontSize
{
	function clientCmdCenterPrint(%text,%duration)
	{
		return parent::clientCmdCenterPrint(fontSize_parseML(%text),%duration);
	}
	function clientCmdBottomPrint(%text,%duration)
	{
		return parent::clientCmdBottomPrint(fontSize_parseML(%text),%duration);
	}
	function newChatHud_AddLine(%text)
	{
		return parent::newChatHud_AddLine(fontSize_parseML(%text));
	}
};
activatepackage(MaxFontSize);